import { nodeResolve } from "@rollup/plugin-node-resolve";
import typescript from "@rollup/plugin-typescript";
import { createRequire } from "module";
const require = createRequire(import.meta.url);
const packageJson = require("./package.json");

const bundlePackage = ["@qorebase/qore-apps", "@qorebase/app-runtime"];

/**
 * @type {import('rollup').RollupOptions}
 */
const rollupOptions = {
  input: `src/${packageJson.module.slice(
    "lib/".length,
    packageJson.module.indexOf(".")
  )}.tsx`,
  output: {
    dir: "lib",
    format: "esm",
  },
  external: (id) => {
    return (
      id.includes("node_modules/") ||
      bundlePackage.some((pkg) => id.includes(pkg))
    );
  },
  plugins: [
    nodeResolve({
      mainFields: ["next", "module", "main"],
      exportConditions: ["next", "default", "module", "import"],
      browser: true,
    }),
    typescript(),
  ],
};

export default rollupOptions;
